
using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Rename.Models;

public record RenameConfiguration(Shared.Models.MetadataConfiguration MetadataConfiguration,
                                  string[] IgnoreExtensions,
                                  bool MoveFilesToRoot,
                                  bool SkipIdFiles,
                                  string[] ValidImageFormatExtensions) : Shared.Models.Properties.IRenameConfiguration
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, RenameConfigurationSourceGenerationContext.Default.RenameConfiguration);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(RenameConfiguration))]
internal partial class RenameConfigurationSourceGenerationContext : JsonSerializerContext
{
}