namespace View_by_Distance.Shared.Models.Stateless.Methods;

public interface IId
{

    string TestStatic_GetIntelligentId(MetadataConfiguration metadataConfiguration, long id, bool ignore) =>
        GetIntelligentId(metadataConfiguration, id, ignore);
    static string GetIntelligentId(MetadataConfiguration metadataConfiguration, long id, bool ignore) =>
        Id.GetIntelligentId(metadataConfiguration, id, ignore);

    int TestStatic_GetId(MetadataConfiguration metadataConfiguration, string intelligentId) =>
        GetId(metadataConfiguration, intelligentId);
    static int GetId(MetadataConfiguration metadataConfiguration, string intelligentId) =>
        Id.GetId(metadataConfiguration, intelligentId);

    string TestStatic_GetPaddedId(MetadataConfiguration metadataConfiguration, int index, int id) =>
        GetPaddedId(metadataConfiguration, index, id);
    static string GetPaddedId(MetadataConfiguration metadataConfiguration, int index, int id) =>
        Id.GetPaddedId(metadataConfiguration, index, id);

    bool TestStatic_NameWithoutExtensionIsIntelligentIdFormat(MetadataConfiguration metadataConfiguration, string fileNameFirstSegment) =>
        NameWithoutExtensionIsIntelligentIdFormat(metadataConfiguration, fileNameFirstSegment);
    static bool NameWithoutExtensionIsIntelligentIdFormat(MetadataConfiguration metadataConfiguration, string fileNameFirstSegment) =>
        fileNameFirstSegment.Length - 1 == metadataConfiguration.IntMinValueLength && fileNameFirstSegment[^1] is '1' or '2' or '8' or '9' && fileNameFirstSegment.All(char.IsNumber);

    bool TestStatic_NameWithoutExtensionIsPaddedIntelligentIdFormat(MetadataConfiguration metadataConfiguration, int sortOrderOnlyLengthIndex, string fileNameFirstSegment) =>
        NameWithoutExtensionIsPaddedIntelligentIdFormat(metadataConfiguration, sortOrderOnlyLengthIndex, fileNameFirstSegment);
    static bool NameWithoutExtensionIsPaddedIntelligentIdFormat(MetadataConfiguration metadataConfiguration, int sortOrderOnlyLengthIndex, string fileNameFirstSegment) =>
        fileNameFirstSegment.Length == metadataConfiguration.IntMinValueLength + sortOrderOnlyLengthIndex + 1
        && fileNameFirstSegment[^1] is '1' or '2' or '8' or '9'
        && fileNameFirstSegment.All(char.IsNumber);

    bool TestStatic_NameWithoutExtensionIsIdFormat(MetadataConfiguration metadataConfiguration, FileHolder fileHolder) =>
        NameWithoutExtensionIsIdFormat(metadataConfiguration, fileHolder);
    static bool NameWithoutExtensionIsIdFormat(MetadataConfiguration metadataConfiguration, FileHolder fileHolder) =>
        Id.NameWithoutExtensionIsIdFormat(metadataConfiguration, fileHolder.NameWithoutExtension.Split('.')[0]);

    int TestStatic_GetDeterministicHashCode(byte[] value) =>
        GetDeterministicHashCode(value);
    static int GetDeterministicHashCode(byte[] value) =>
        Id.GetDeterministicHashCode(value);

}